/*
 				coadd.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	Swarp
*
*	Author:		E.BERTIN (IAP)
*
*	Contents:	Include file for coadd.c
*
*	Last modify:	06/08/2001
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*
 04.09.2008:
 Inclusion of the co-addition mode SUM - a simple sum of the input frames
*/

#ifndef _FITSCAT_H_
#include "fits/fitscat.h"
#endif

#ifndef _FIELD_H_
#include "field.h"
#endif

#ifndef	_COADD_H_
#define	_COADD_H_

/*-------------------------------- macros -----------------------------------*/
/*------------------------------- constants ---------------------------------*/
/*--------------------------------- typedefs --------------------------------*/
typedef enum {COADD_MEDIAN, COADD_AVERAGE, COADD_MIN, COADD_MAX,
		COADD_WEIGHTED, COADD_CHI2, COADD_SUM}
			coaddenum;	/* Coaddition type */

/*-------------------------- structure definitions --------------------------*/

/*----------------------- miscellaneous variables ---------------------------*/

/*-------------------------------- protos -----------------------------------*/

extern PIXTYPE	fast_median(PIXTYPE *arr, int n),
		hmedian(PIXTYPE *arr, int n);
extern int	coadd_fields(fieldstruct **infield, fieldstruct **inwfield,
			int ninput, fieldstruct *outfield,
			fieldstruct *outwfield,
			coaddenum coaddtype, PIXTYPE wthresh),
		coadd_pix(PIXTYPE *inpix, PIXTYPE *inwpix, int ninput,
			PIXTYPE *outpix , PIXTYPE *outwpix,
			coaddenum coaddtype, PIXTYPE wthresh);
#endif
